{*******************************************************************************}
{                                                                               }
{ FileName     : fmBaseScreen.pas                                               }
{                                                                               }
{ Author       : Ian Lane (Email: lanei@ideal.net.au)                           }
{                                                                               }
{ Synopsis     : Both our preview screen and our actual screen saver descend    }
{                from this common ancestor.                                     }
{                                                                               }
{ Distribution : This program is free for public use as long as credit is given }
{                to the author.                                                 }
{                                                                               }
{                          Copyright (c) 1998 Ian Lane                          }
{                                                                               }
{*******************************************************************************}
unit fmBaseScreen;

interface

uses
  Classes, Controls, ExtCtrls, Forms, Messages, ULife;

type
  TfrmBaseScreen = class(TForm)
    cmpLife: TLife;
    tmrSpeed: TTimer;
    procedure FormCreate(Sender : TObject);
    procedure tmrSpeedTimer(Sender : TObject);
  private
    procedure WMSysCommand(var Msg : TWMSysCommand); message WM_SYSCOMMAND;
  end;

implementation

uses
  Windows;

{$R *.DFM}

procedure TfrmBaseScreen.FormCreate(Sender : TObject);

var
  x : Integer;
  y : Integer;

begin
  // Create a random pattern of cells
  Randomize;
  with cmpLife do
    for x := 0 to GridWidth - 1 do
      for y := 0 to GridHeight - 1 do
        if Random < 0.5 then
          Cells[x, y] := True
        else
          Cells[x, y] := False
end;

procedure TfrmBaseScreen.tmrSpeedTimer(Sender : TObject);

begin
  cmpLife.NextGeneration
end;

procedure TfrmBaseScreen.WMSysCommand(var Msg : TWMSysCommand);

begin
  if Msg.CmdType = SC_SCREENSAVE then
    Msg.Result := 1 { Do not activate the saver more than once }
  else
    Inherited
end;

end.
